angular.module('beamng.apps')
.directive('nordsTimer', ['Utils', function (Utils) {
  return {
	templateUrl: "/ui/modules/apps/nordsTimer/nordstimer.html",
    //template:  '<p>Lap time: {{all.lapTime}}<br>Car config: {{all.carConfig}}<br>Test: {{leaderboard}}<br></p>',
    replace: true,
    restrict: 'EA',
    link: function (scope, element, attrs) {
      // An optional list of streams that will be used in the app
      var streamsList = ['stats', 'sensors', 'electrics', 'engineInfo'];

      // Make the needed streams available.
      StreamsManager.add(streamsList);

	  scope.all;
	  scope.time;
	  scope.carConfig;
	  scope.leaderboard = [];
	  scope.filteredLeaderboard = "";

	  var index = 0;

      // Make sure we clean up after closing the app.
      scope.$on('$destroy', function () {
        StreamsManager.remove(streamsList);
      });

	  scope.$on('sendTimer', function (event, json_data) {
		scope.all = JSON.parse(json_data);
		//index = scope.leaderboard.findIndex(({ lapTime }) => lapTime == scope.all.lapTime);
		if (index === -1) {
			scope.leaderboard.push(scope.all);
		} else {
			scope.leaderboard[index] = scope.all;
		}
		index = index + 1;
		scope.leaderboard.sort(function(a, b) {
			return a.lapTime - b.lapTime;
		});
		scope.filteredLeaderboard = scope.leaderboard.map(({ lapTime, endTime, carConfig }) => ({
			lapTime,
			endTime, 
			carConfig
		}));	
		scope.$apply();
	  });

	  scope.$on('showTimer', function (event, json_data) {
		scope.all = JSON.parse(json_data);	
		scope.time = scope.all.endTime;
		scope.carConfig = scope.all.carConfig;
		scope.$apply();
	  });
	  
      scope.$on('streamsUpdate', function (event, streams) {
        /* Some code that uses the streams' values */
      });
    }
  };
}]);
